Subject: Re: [PATCH RFC net] docs: netdev: document guidance on cleanup patches

From: Simon Horman <[email-masked]>
Date: Mon, 7 Oct 2024 17:15:01 +0100

On Mon, Oct 07, 2024 at 09:08:28AM -0700, Jakub Kicinski wrote:
> On Mon, 7 Oct 2024 16:55:21 +0100 Simon Horman wrote:
> > > > +Netdev discourages patches which perform simple clean-ups, which are not in
> > > > +the context of other work. For example addressing ``checkpatch.pl``
> > > > +warnings, or :ref:`local variable ordering<rcs>` issues. This is because it
> > > > +is felt that the churn that such changes produce comes at a greater cost
> > > > +than the value of such clean-ups.  
> > > 
> > > Should we add "conversions to managed APIs"? It's not a recent thing,
> > > people do like to post patches doing bulk conversions which bring very
> > > little benefit.  
> > 
> > Well yes, I agree that is well established, and a common target of patches.
> > But isn't that covered by the previous section?
> > 
> >    "Using device-managed and cleanup.h constructs
> >     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> > 
> >    "Netdev remains skeptical about promises of all “auto-cleanup” APIs,
> >     including even devm_ helpers, historically. They are not the preferred
> >     style of implementation, merely an acceptable one.
> > 
> >     ...
> > 
> >    https://docs.kernel.org/process/maintainer-netdev.html#using-device-managed-and-cleanup-h-constructs
> > 
> > We could merge or otherwise rearrange that section with the one proposed by
> > this patch. But I didn't feel it was necessary last week.
> 
> Somewhat, we don't push back on correct use of device-managed APIs.
> But converting ancient drivers to be device-managed just to save 
> 2 or 3 LoC is pointless churn. Which in my mind falls squarely
> under the new section, the new section is intended for people sending
> trivial patches.

Thanks, I can try and work with that. Do you want to call out older drivers
too? I was intentionally skipping that for now. But I do agree it should
be mentioned at some point.

> > > On the opposite side we could mention that spelling fixes are okay.
> > > Not sure if that would muddy the waters too much..  
> > 
> > I think we can and should. Perhaps another section simply stating
> > that spelling (and grammar?) fixes are welcome.
> 
> Hm, dunno, for quotability I'd have a weak preference for a single
> section describing what is and isn't acceptable as a standalone cleanup.

Sure.